<?php
/*=============
#Ultimate Form Mail Script
#Version 2.0 Beta
#
# Copyright 2003 Jack Born (c) All rights reserved.
# Created 06/29/03 Last Modified 11/20/03
# Jack Born http://www.surefirewebdesign.com
#
# This cannot and will not be inforced but I would appreciate a link back
# to my site:
#
# http://www.surefirewebdesign.com/
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
# THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR
# OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
# ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
# OTHER DEALINGS IN THE SOFTWARE.
#
==============*/
class UFMail {
var $website;
var $email;
var $p_vars;
var $recipient;
var $testing;
var $subject;
var $redirect;
var $banlist;
var $headerfile;
var $footerfile;
var $cssfile;
var $banned_ext;
var $max_file_size;
var $env_report;
var $autoresponder;
var $auto_from;
var $auto_from_name;
var $auto_content;
var $auto_reply;
var $auto_reply_name;
var $first_name;
var $ignore_these;
var $error_message;
var $webmaster_body;
var $required;
var $required_check;
var $receipt;
var $rcpt;
var $referer_check;
var $date_format;
var $dropdown_name;
var $dropdown_recipient;
var $dropdown_list;

function initialize()
{
$this->p_vars = $_POST;
$this->post_keys  = array_keys($this->p_vars);
$this->ignore_these = array('Submit','submit','required', 'Required');
$this->keep_these = array_diff($this->post_keys, $this->ignore_these);

//set the recipient
if(isset($this->dropdown_recipient) && ($this->dropdown_recipient == '1'))
{
define('drop_name', $this->dropdown_name);
if(!isset($this->p_vars[drop_name]))
{
$this->error_message .= "Your drop down form field is missing or doesn't match<br>";
}
else
{
define('chosen_email_id', $this->p_vars[drop_name]);
$chosen_email = $this->dropdown_list[chosen_email_id];
$this->recipient = "";
$this->recipient = array($chosen_email);
}
}//end of dropdown


//if($this->p_vars['required'] && $this->p_vars['required'] != "")
if(isset($this->p_vars['required']))
{
$require = explode(",", $this->p_vars['required']);
foreach($require as $req)
{
$required[] = trim($req);
}
$this->required = $required;

}//end of if required

}//end of function initialize

/****************************/


function check_vars()
{
//first check the referer
if($this->referer_check == 1)
{
$form_pg = explode("/", $_SERVER['HTTP_REFERER']);
$form_page = $form_pg[2];
$script_page = $_SERVER['SERVER_NAME'];
if($form_page != $script_page)
{
$this->error_message .= "Posted info from $form_page but should be $script_page<br>";
}
}//end of referer check

if(is_array($this->required))
{
$test = array_keys($this->p_vars);
$diff = array_diff($this->required, $test);
if($diff)
{
foreach($diff as $dif)
{
$this->error_message .= "$dif is required but not found<br>";
}
}
}

foreach($this->p_vars as $key=>$value)
{
if(!in_array($key, $this->keep_these))
{
continue;
}
if(is_array($this->required))
{
if((in_array($key, $this->required)) && ($value == ""))
{
$this->error_message .= "$key is required but not found<br>";
}
if((in_array($key, $this->required)) && ($value != ""))
{
$this->required_check .= "$key is required AND found<br>";
}
}

if(is_array($value))
{
$key1 = $key;
if(is_array($this->required))
{
if((in_array($key, $this->required)) && (count($value) < 1))
{
$this->error_message .= "$key is required but not found<br>";
}
if((in_array($key, $this->required)) && (count($value) > 0))
{
$this->required_check .= "$key is required AND found<br>";
}
}
foreach($value as $k=>$v)
{
$t = $k+1;
$this->webmaster_body .= "$key1($t): $v<br>";
}
}
else
{
if($key == 'email' && $value != "")
{
if (!eregi("^[_\.0-9a-z-]+@([0-9a-z][0-9a-z-]+\.)+[a-z]{2,3}$", $value)) 
{
$this->error_message .= ("Your email address is invalid<br>");
}
if($this->check_banlist($value) == 0)
{
$this->error_message .= ("This email address isn't allowed<br>");
}
}//end of if email

if($key == 'recipient_menu')//this is for drop down list of recipients in form
{
if(in_array($value, $this->recipient))
{
$this->recipient = "";
$this->recipient = array($value);
}
else
{
$this->error_message .= ("The recipient you chose wasn't found<br>");
}
}//end of recipient_menu

if($key == 'zip' || $key == 'zipcode' || $key == 'zip_code')
{
if($value != "")
{
if (!ereg("(^[0-9]{5})-([0-9]{4}$)", trim($value)) && (!ereg("^[a-zA-Z][0-9][a-zA-Z][[:space:]][0-9][a-zA-Z][0-9]$", trim($value))) && (!ereg("(^[0-9]{5})", trim($value)))) {

$this->error_message .= ("Your zip code is invalid<br>");
}
}
}//end of if zip code

if($key == 'phone' || $key == 'phone_number' || $key == 'phone_no')
{
if($value != "")
{
if (!ereg("(^(.*)[0-9]{3})(.*)([0-9]{3})(.*)([0-9]{4}$)", $value)) 
{
$this->error_message .= ("Your zip code is invalid<br>");
}
}
}//end of if phone number

$this->webmaster_body .= "$key: $value<br>";
}
}
}//end function check_vars

/****************************/

function branch()
{
if(isset($this->headerfile) && ($this->testing == 1 || isset($this->error_message)))
{
error_reporting(0);
include $_SERVER['DOCUMENT_ROOT'].$this->headerfile;

}
if($this->testing == 1)
{
print("<h1>Test Results:</h1>");
if($this->error_message && $this->error_message != "")
{
print("<h2>No email would be sent</h2>$this->error_message<br><br>");
}
else
{
if(is_array($this->recipient))
{
foreach($this->recipient as $to)
{
print("<h2>The message would have been sent to $to</h2>");
}
}
else
{
print("<h2>The message would have been sent to $this->recipient</h2>");
}
}
if($this->required_check && $this->required_check != "")
{
print("$this->required_check<br>");
}
$now = date($this->date_format);
print("$now is time<br>");

print("<h2>The message would be:</h2>$this->webmaster_body");
print("<h2>These variables were set in the configuration</h2>");
if($this->autoresponder == 1)
{
print("An auto reply would be sent from " . $this->auto_from_name ." at email address " . $this->auto_from . ".<br>");
if($this->receipt == 1)
{
print("And you have decided to send a receipt.<br>");
}
}
else
{
print("NO auto reply would be sent from " . $this->auto_from_name ." at email address " . $this->auto_from . ".<br>");
}
if(isset($this->website))
{
print("You indicate the website address is " . $this->website . ".<br>");
}
if($this->referer_check == 1)
{
print("You've decided to check the refering website.<br>");
$form_pg = explode("/", $_SERVER['HTTP_REFERER']);
$form_page = $form_pg[2];
$script_page = $_SERVER['SERVER_NAME'];
if($form_page != $script_page)
{
print("Posted info from $form_page but should be $script_page<br>");
}
else
{
print("Success! The form and this script are both on the same site.<br>");
}
}//end of referer check
print("<h2>You should turn off testing mode if you are satisfied with the results</h2>");
}//end of testing = 1
else
{
if($this->error_message && $this->error_message != "")
{
print("<h2>No email sent</h2>$this->error_message<br><br>");
}//end of if error message
else
{
//send the emails
$this->autoreply();
$this->webmaster_notify();
}
}

if(isset($this->footerfile) && ($this->testing == 1 || isset($this->error_message)))
{
include $_SERVER['DOCUMENT_ROOT'].$this->footerfile;
}
}//end of function branch

/***************************/

function autoreply()
{
if($this->autoresponder == 1)
{
$rcpt = "";
if($this->receipt == 1)
{
$rcpt = "Here is what you sent to us:

";
$rcpt .= str_replace("<br>", "
", $this->webmaster_body);
$rcpt .= "
";
}
if($this->auto_reply_name == "")
{
$this->auto_reply_name = $this->auto_from_name;
}
if($this->auto_reply == "")
{
$this->auto_reply = $this->auto_from;
}
$mail = new phpmailer();
$mail->IsSMTP();                                      // set mailer to use SMTP
$mail->Host = "localhost";  // specify main and backup server
$mail->SMTPAuth = false;    // turn on SMTP authentication

$mail->From = $this->auto_from;
$mail->FromName = $this->auto_from_name;
$mail->AddAddress($this->p_vars['email']);                 // name is optional
$mail->AddReplyTo($this->auto_reply, $this->auto_reply_name);
//$mail->IsHTML(false);                                  // set email format to HTML

$mail->Subject = "Thank you for visiting " . $this->website;

$mail->Body = "We received your information and will be getting back to you shortly.

$rcpt" . $this->website;

//$mail->AltBody = "Alt body here";

if(!$mail->Send())
{
   echo "Message could not be sent. ";
   echo "Mailer Error: " . $mail->ErrorInfo;
}
else
{
if($this->redirect != "")
{
//nothing
}
else
{
print("Sent auto-reply to " . $this->p_vars['email']);
}
}
}
}//end of function autoreply

function webmaster_notify()
{
$now = date($this->date_format);

$message_body = str_replace("<br>", "
", $this->webmaster_body);

$mail = new phpmailer();
$mail->IsSMTP();           // set mailer to use SMTP
$mail->Host = "localhost";  // specify main and backup server
$mail->SMTPAuth = false;    // turn on SMTP authentication

$mail->From = $this->p_vars['email'];
$mail->FromName = $this->p_vars['email'];
if(is_array($this->recipient))
{
foreach($this->recipient as $to)
{
$mail->AddAddress($to); 
}
}
else
{
$mail->AddAddress($this->recipient);  
}               // name is optional
$mail->AddReplyTo($this->p_vars['email']);
//$mail->IsHTML(false);                                  // set email format to HTML

$mail->Subject = "Contact from your website " . $this->website;

$mail->Body = "Here is the information sent to you on $now:

" . $message_body;

//$mail->AltBody = "Alt body here";

if(!$mail->Send())
{
   echo "Message could not be sent. ";
   echo "Mailer Error: " . $mail->ErrorInfo;
}
else
{
if($this->redirect != "")
{
//nothing
}
else
{
if(is_array($this->recipient))
{
foreach($this->recipient as $to)
{
print("<br>Sent message to " . $to);
}
}
else
{
print("<br>Sent message to " . $this->recipient);
}
}
}
}//end of function webmaster_notify

function thanks_page()
{
if($this->redirect != "" && (!isset($this->error_message)))
{
$page = $this->redirect;
header("Location: $page");
exit;
}
}//end of function thanks_page

/******************************/

// function to check the banlist
function check_banlist($email) 
{
$allow = 0;
if (count($this->banlist)) 
{
$allow = true;
foreach($this->banlist as $banned) 
{
$temp = explode("@", $banned);
if ($temp[0] == "*") 
{
$temp2 = explode("@", $email);
if (trim(strtolower($temp2[1])) == trim(strtolower($temp[1])))
{
$allow = 0;
}
} else {

if (trim(strtolower($email)) == trim(strtolower($banned)))
{
$allow = 0;
}
}
}
}
return $allow;
}//end check_banlist function

}//end of class

?>